pragma Spark_Mode (On);
package Sorters is

   type Array_Type is array (Positive range <>) of Integer;

   -- Returns True if A is a permuation of B
   function Perm(A : in Array_Type;
                 B : in Array_Type) return Boolean
     with
       Global => null,
       Ghost  => True,
       Import => True;

   -- Sorts the elements in the array Values in ascending order
   procedure Selection_Sort(Values : in out Array_Type)
     with
       Depends => (Values => Values),
       Pre => Values'Length >= 1,
     Post =>
       (for all I in Values'First .. Values'Last - 1 => Values(I) <= Values(I + 1)) and
       Perm(Values'Old, Values);

end Sorters;
